### (c) TIG 2009
### makes 2 true tangents from selected cpoint to selected arc/circle
### adds point at ends, arc centre and radii and clines
require 'sketchup.rb'
def truetangents()
  model=Sketchup.active_model
  ents=model.active_entities
  ss=model.selection
  if not ss[0] or not ss[1]
    puts "Selection must contain a Point and an Arc !"
    return nil
  end#if
  ppt=nil; ss.each{|e|ppt=e if e.typename=="ConstructionPoint"}
  arc=nil; ss.each{|e|arc=e.curve if e.typename=="Edge" and e.curve and e.curve.typename=="ArcCurve"}
  if not ppt or not arc
    puts "Selection must contain a Point and an Arc !"
    return nil
  end#if
  pt0=ppt.position
  if not pt0.on_plane?(arc.plane)
      puts "Point must be on the Arc's Plane !"
    return nil
  end#if
  cen=arc.center; rad=arc.radius; nor=arc.normal
  dis=pt0.distance(cen)
  if dis<=rad
    puts "Point must be Outside the Arc's Circumference !"
    return nil
  end#if
  ang=Math::acos(rad/dis)
  ###
  model.start_operation("True Tangents")
  ###
  ents.add_cpoint(pt0)
  ents.add_cline(pt0,pt0)
  ents.add_cpoint(cen)
  ents.add_cline(pt0,cen)
  pt1=Geom::Point3d.linear_combination((dis-rad)/dis,cen,(rad/dis),pt0)
  rot1=Geom::Transformation.rotation(cen,nor,ang)
  pt1.transform!rot1
  ents.add_cpoint(pt1)
  pt2=Geom::Point3d.linear_combination((dis-rad)/dis,cen,(rad/dis),pt0)
  rot2=Geom::Transformation.rotation(cen,nor,-ang)
  pt2.transform!rot2
  ents.add_cpoint(pt2)
  ents.add_cline(pt0,pt1)
  ents.add_cline(pt0,pt2)
  ents.add_cline(cen,pt1)
  ents.add_cline(cen,pt2)
  ###
  model.commit_operation
end#def
###
### this draws clines and points for common-tangents to any 2 selected arcs/circles
def commontangents()
  model=Sketchup.active_model
  ents=model.active_entities
  ss=model.selection
  if not ss[0] or not ss[1]
    puts "Selection must contain 2 Arcs !"
    return nil
  end#if
  arc1=nil; ss.each{|e|arc1=e.curve if e.typename=="Edge" and e.curve and e.curve.typename=="ArcCurve"}
  arc2=nil; ss.each{|e|arc2=e.curve if e.typename=="Edge" and e.curve and e.curve.typename=="ArcCurve" and e.curve!=arc1}
  if not arc1 or not arc2
    puts "Selection must contain a 2 Arcs !"
    return nil
  end#if
  cen1=arc1.center; rad1=arc1.radius; nor1=arc1.normal, pla1=arc1.plane
  cen2=arc2.center; rad2=arc2.radius; nor2=arc2.normal, pla2=arc2.plane
  if nor1 != nor2 and nor1 != nor2.reverse!
    puts "#Arcs must be coplanar !"
    #return nil
  end#if
  if pla1 != pla2
    puts "Arcs must be coplanar !"
    return nil
  end#if
  dis=cen1.distance(cen2)
  if dis<=((rad1-rad2).abs)
    puts "Arcs Fully Overlap !"
    return nil
  end#if
    def lapped(arc1,arc2)
      model=Sketchup.active_model
      ents=model.active_entities
      model.start_operation("Common Tangents [Lapped]")
    cen1=arc1.center; rad1=arc1.radius; nor1=arc1.normal
    cen2=arc2.center; rad2=arc2.radius; nor2=arc2.normal
    dis=cen1.distance(cen2)
    ang=Math::acos((rad1-rad2).abs/dis)
    pt1=Geom::Point3d.linear_combination(rad1/dis,cen2,(dis-rad1)/dis,cen1)
    rot1=Geom::Transformation.rotation(cen1,nor1,ang.abs)
    pt1.transform!rot1
     pt2=Geom::Point3d.linear_combination(rad1/dis,cen2,(dis-rad1)/dis,cen1)
    rot2=Geom::Transformation.rotation(cen1,nor1,-(ang.abs))
    pt2.transform!rot2
     pt3=cen2.clone
    pt3.offset!((pt1-cen1),rad2)
     pt4=cen2.clone
    pt4.offset!((pt2-cen1),rad2)
     ents.add_cpoint(cen1)
    ents.add_cpoint(cen2)
    ents.add_cpoint(pt1)
    ents.add_cpoint(pt2)
    ents.add_cpoint(pt3)
    ents.add_cpoint(pt4)
    ents.add_cline(cen1,cen2)
    ents.add_cline(cen1,pt1)
    ents.add_cline(cen1,pt2)
    ents.add_cline(cen2,pt3)
    ents.add_cline(cen2,pt4)
    ents.add_cline(pt1,pt3)
    ents.add_cline(pt2,pt4)
      model.commit_operation
    end#def
  if dis<=rad1+rad2
    lapped(arc1,arc2)### partial lap
    return nil
  end#if
  ###
  model.start_operation("Common Tangents")
  ###
  ents.add_cpoint(cen1)
  ents.add_cline(cen1,cen2)
  ents.add_cpoint(cen2)
  pt0=Geom::Point3d.linear_combination(((dis*rad2)/(rad1+rad2))/dis,cen1,(dis-((dis*rad2)/(rad1+rad2)))/dis,cen2)
  ents.add_cpoint(pt0)
  ### arc1
  cen=arc1.center; rad=arc1.radius; nor=arc1.normal
  dis=pt0.distance(cen)
  ang=Math::acos(rad/dis)
  ###
  ents.add_cpoint(pt0)
  ents.add_cline(pt0,pt0)
  ents.add_cpoint(cen)
  ents.add_cline(pt0,cen)
  pt1=Geom::Point3d.linear_combination((dis-rad)/dis,cen,(rad/dis),pt0)
  rot1=Geom::Transformation.rotation(cen,nor,ang)
  pt1.transform!rot1
  ents.add_cpoint(pt1)
  pt2=Geom::Point3d.linear_combination((dis-rad)/dis,cen,(rad/dis),pt0)
  rot2=Geom::Transformation.rotation(cen,nor,-ang)
  pt2.transform!rot2
  ents.add_cpoint(pt2)
  ents.add_cline(pt0,pt1)
  ents.add_cline(pt0,pt2)
  ents.add_cline(cen,pt1)
  ents.add_cline(cen,pt2)
  ### arc2
  cen=arc2.center; rad=arc2.radius; nor=arc1.normal
  dis=pt0.distance(cen)
  ang=Math::acos(rad/dis)
  ###
  ents.add_cpoint(pt0)
  ents.add_cline(pt0,pt0)
  ents.add_cpoint(cen)
  ents.add_cline(pt0,cen)
  pt1=Geom::Point3d.linear_combination((dis-rad)/dis,cen,(rad/dis),pt0)
  rot1=Geom::Transformation.rotation(cen,nor,ang)
  pt1.transform!rot1
  ents.add_cpoint(pt1)
  pt2=Geom::Point3d.linear_combination((dis-rad)/dis,cen,(rad/dis),pt0)
  rot2=Geom::Transformation.rotation(cen,nor,-ang)
  pt2.transform!rot2
  ents.add_cpoint(pt2)
  ents.add_cline(pt0,pt1)
  ents.add_cline(pt0,pt2)
  ents.add_cline(cen,pt1)
  ents.add_cline(cen,pt2)
  ###
  model.commit_operation
end#def
###
if not file_loaded?(File.basename(__FILE__)) ### so only get menu item once...
    UI.menu("Plugins").add_item("True Tangents"){truetangents} ###
    UI.menu("Plugins").add_item("Common Tangents"){commontangents} ###
end#if ###
file_loaded(File.basename(__FILE__)) ###